﻿Public Class frmMain
    Delegate Sub SetTextCallback(ByVal byte1 As Byte)
    Dim WithEvents serial As New System.IO.Ports.SerialPort
    Dim received As New ArrayList


    Private Sub Form1_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed
        Try
            If (serial.IsOpen) Then
                serial.ReadExisting()
                serial.Close()
            End If
            serial.Dispose()
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".disposed" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            ListBox1.Items.AddRange(System.IO.Ports.SerialPort.GetPortNames())
            ListBox1.SelectedIndex = 0
            serial.BaudRate = 9600
            serial.DataBits = 8
            serial.DiscardNull = False
            serial.Encoding = System.Text.Encoding.ASCII
            serial.Handshake = IO.Ports.Handshake.None
            serial.Parity = IO.Ports.Parity.None
            serial.StopBits = IO.Ports.StopBits.One
            serial.ReadTimeout = 500
            serial.WriteTimeout = 500
            serial.ReceivedBytesThreshold = 1
            updatebuttons()
            Timer1.Enabled = True
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".disposed" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub serialin(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles serial.DataReceived
        Try
            Dim byte1 As Byte
            If serial.IsOpen Then
                While serial.BytesToRead > 0
                    byte1 = CByte(serial.ReadByte())
                    received.Add(byte1)
                End While
            End If
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".serialin " + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        Try
            serial.PortName = ListBox1.SelectedItem.ToString
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".indexchanged" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub updatebuttons()
        Try
            If serial.IsOpen Then
                btnConnect.Text = "disconnect"
                btnTransmitBytes.Enabled = True
            Else
                btnConnect.Text = "connect"
                btnTransmitBytes.Enabled = False
            End If
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".updatebuttons" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Try
            If serial.IsOpen Then
                Timer1.Enabled = False
                serial.ReadExisting()
                serial.Close()
            Else
                serial.Open()
                Timer1.Enabled = True
            End If
            updatebuttons()
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".connect" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub sendtext(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtStringTx.KeyPress
        Try
            serial.Write(e.KeyChar)
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".sendtext" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTransmitBytes.Click
        Dim row As DataGridViewRow
        Dim x(1) As Byte
        Dim item As Object
        For Each row In DataGridView1.Rows
            item = row.Cells(0).FormattedValue
            If (item Is Nothing) Then
                MessageBox.Show("item is nothing", "Error", MessageBoxButtons.OK)
            Else
                If item.ToString = "" Then
                Else
                    x(0) = 0
                    Try
                        x(0) = Byte.Parse(item.ToString)
                        serial.Write(x, 0, 1)
                    Catch ex As Exception
                        MessageBox.Show("item is not a byte", "Error", MessageBoxButtons.OK)
                    End Try
                End If
            End If
        Next
    End Sub
    Private Sub btnClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAll.Click
        Try
            received.Clear()
            txtHexRx.Text = ""
            txtStringRx.Text = ""
            txtStringTx.Text = ""
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".clearall " + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub ValidateBytesGrid(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellValidatingEventArgs) Handles DataGridView1.CellValidating
        Dim item As Object
        Dim x As Byte
        item = e.FormattedValue
        If (item Is Nothing) Then
            MessageBox.Show("item is nothing", "Error", MessageBoxButtons.OK)
        Else
            If item.ToString = "" Then
                If (e.RowIndex < DataGridView1.RowCount - 1) Then
                    MessageBox.Show("item is empty", "Error", MessageBoxButtons.OK)
                    e.Cancel = True
                End If
            Else
                x = 0
                Try
                    x = Byte.Parse(item.ToString)
                    x = x
                Catch ex As Exception
                    MessageBox.Show("item is not a byte", "Error", MessageBoxButtons.OK)
                    'DataGridView1.Item(e.ColumnIndex, e.RowIndex).Value = 0
                    'DataGridView1.CurrentCell = DataGridView1.Item(e.ColumnIndex, e.RowIndex)
                    'DataGridView1.
                    e.Cancel = True
                End Try
            End If
        End If
    End Sub
    Private Sub AddRowToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddRowToolStripMenuItem.Click
        Try
            Dim rowindex As Integer = 0
            If DataGridView1.SelectedRows.Count > 0 Then
                Dim row As DataGridViewRow
                Dim i As Integer = DataGridView1.SelectedRows(0).Index
                For Each row In DataGridView1.SelectedRows
                    If row.Index < i Then
                        i = row.Index
                    End If
                Next
                rowindex = i
            End If
            DataGridView1.Rows.Insert(rowindex, 0, 1)
            DataGridView1.CurrentCell = DataGridView1.Item(0, rowindex)
            DataGridView1.BeginEdit(True)
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".insertrow" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub DeleteRowToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteRowToolStripMenuItem.Click
        Try
            Dim row As DataGridViewRow
            For Each row In DataGridView1.SelectedRows
                If Not row.IsNewRow Then
                    DataGridView1.Rows.Remove(row)
                End If
            Next
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".deleterow" + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Try

            While received.Count > 0
                txtStringRx.Text += (Microsoft.VisualBasic.Chr(CByte(received(0))))
                txtHexRx.Text += CByte(received(0)).ToString + vbCrLf
                received.RemoveAt(0)
            End While
            If txtStringRx.Text.Length > 255 Then
                txtStringRx.Text = txtStringRx.Text.Substring(txtStringRx.Text.Length - 255)
            End If
            If txtHexRx.Text.Length > 255 Then
                txtHexRx.Text = txtHexRx.Text.Substring(txtHexRx.Text.Length - 255)
            End If
        Catch ex As Exception
            MessageBox.Show(Me.Name + ".settext " + ex.Message, "Exception", MessageBoxButtons.OK)
        End Try
    End Sub
End Class